#pragma once

#include "prototypes.h"
#include "functions.h"
#include "Effect.h"

class Blur2DBlob {
private:
	accum88 _x_freq;
	accum88 _y_freq;
	uint8_t _color_freq;
public:
	Blur2DBlob();
	void render(Window* win);
};

class Blur2DEffect : public Effect {
private:
	Window* window = &Window::window_with_clock;
	uint8_t _count;
	Blur2DBlob* _blobs;
public:
	Blur2DEffect();
	~Blur2DEffect();
	void _init();
	void _delete();
    boolean supports_window = true;
    boolean can_be_shown_with_clock();
    void loop(uint16_t ms);
    String get_name() override { return "blur2d"; }
};

