#include "SimpleEffect.h"

void SimpleEffect::loop(uint16_t ms) {
    if (_fade_out) window->fadeToBlackBy(3);
    accum88 t = millis() * 0x100 / 1000;
    for(uint8_t x=0; x<window->width; x++) for(uint8_t y=0; y<window->height; y++) {
        uint16_t i = y*window->width + x;
        int8_t r = _method(t, i, x, y);
        
        if (_fade_out && r==0) {
            continue;
        }

        CRGB color;
        if (_random_colors) {
            color = CHSV(random8(), 255, abs(r)*2);
        } else {
            color = CHSV(_cycle_color ? baseHue : _color, r<0?0:255, abs(r)*2);
        }
        
        window->setPixel(x, y, &color);
    }
}